var gpsInfo = "";
var gpsLocation = null;
var appDefName = "掌乾坤";

function getAppName() {
	return getStorage("appname");
}

function valid(id, type) {

	var userToken = Session("userid");
	if(userToken && userToken != "") {
		if(type == null || type == undefined) {
			type = "viewsource";
		}
		if(("," + Session(type) + ",").indexOf("," + id + ",") != -1) {
			return true;
		} else {
			return false;
		}
	} else {
		return false;
	}
}

function logout() {
	var tmp=getAppName();
	plus.storage.clear();
	setStorage("appname", tmp);
}
(function($) {
	$.enterfocus = function(selector, callback) {
		var boxArray = [].slice.call(document.querySelectorAll(selector));
		for(var index in boxArray) {
			var box = boxArray[index];
			box.addEventListener('keyup', function(event) {
				if(event.keyCode == 13) {
					var boxIndex = boxArray.indexOf(this);
					if(boxIndex == boxArray.length - 1) {
						if(callback) callback();
					} else {
						//console.log(boxIndex);
						var nextBox = boxArray[++boxIndex];
						nextBox.focus();
					}
				}
			}, false);
		}
	};
}(window.mui = window.mui || {}));
window.addEventListener("swiperight", function() {
	var main = plus.webview.currentWebview().parent();
	if(main != null) {
		mui.fire(main, 'swiperight');
	}
});

window.addEventListener("swipeleft", function() {
	var main = plus.webview.currentWebview().parent();
	if(main != null) {
		mui.fire(main, 'swipeleft');
	}
});

function popWindow(url) {
	if(url.Contains(".aspx")) {
		return popRemoteWindow(url);
	}
	var aniShow = "slide-in-right";
	var webview_style = {
		popGesture: "close",
		softinputMode: "adjustResize"
	};
	if(document.URL.Contains(".aspx")) {
		var urlInfo = url.split('?');
		if(urlInfo.length == 1) {
			url = "file://" + plus.io.convertLocalFileSystemURL("_www/" + url);
		} else {
			url = "file://" + plus.io.convertLocalFileSystemURL("_www/" + urlInfo[0]) + "?" + urlInfo[1];
		}
	}
	mui.openWindow({
		id: url,
		url: url,
		styles: webview_style,
		show: {
			aniShow: aniShow
		},
		waiting: {
			autoShow: false
		}
	});
}

function padLeft(str, len) {
	var result = str + "";
	while(result.length < len) {
		result = "0" + result;
	}
	return result;
}

var files = [];
// 上传文件
function uploadFile(callBack, optype, waitingText) {
	var server = plus.storage.getItem("url") + "/Extensions/ExtFileUpload/UploadHandler.ashx";
	if(files.length <= 0) {
		callBack("");
	} else {
		var wt = plus.nativeUI.showWaiting(waitingText, {
			background: "rgba(0,0,0,0.3)",
			padlock: true
		});
		var task = plus.uploader.createUpload(server, {
				method: "POST"
			},
			function(t, status) { //上传完成
				files.forEach(function(file) {
					if(optype != "chatfile") {
						plus.io.resolveLocalFileSystemURL(file.path, function(f) {
							f.remove();
						});
					}
				});
				files = [];
				plus.nativeUI.closeWaiting();
				if(status == 200) {
					callBack(t.responseText);
				} else {
					mui.toast("保存失败，请重新尝试！");
					wt.close();
				}
			}
		);
		task.addData("userid", plus.storage.getItem("userid"));
		task.addData("gpsinfo", gpsInfo);
		task.addData("optype", optype);
		for(var i = 0; i < files.length; i++) {
			var f = files[i];
			task.addFile(f.path, {
				key: f.name
			});
		}
		task.start();
	}
}

var index = 1;

function appendFile(file) {
	files.push({
		name: "uploadkey" + index,
		path: file
	});
	index++;
}

//function getPageSourceID() {
//	var sourceID = V("sourceid");
//	if (sourceID == "") {
//		var url = document.URL;
//		url = url.substr(url.lastIndexOf("/") + 1);
//		if (url.Contains("?")) {
//			url = url.substr(0, url.indexOf("?"));
//		}
//		try {
//			var sourcelist = [].slice.call(JSON.parse(getStorage("sourcelist")));
//			sourcelist.forEach(function(s) {
//				if (s.url.replace(/.aspx/img, ".html").Contains(url) || s.exturl.replace(/.aspx/img, ".html").Contains(url)) {
//					sourceID = s.id;
//				}
//			});
//		} catch (ex) {}
//	} else if (isNaN(sourceID)) {
//		var sourcelist = [].slice.call(JSON.parse(getStorage("sourcelist")));
//		sourcelist.forEach(function(s) {
//			if (s.sourceid == sourceID) {
//				sourceID = s.id;
//			}
//		});
//
//	}
//	return sourceID;
//
//}

function recordvideo(callBack) {
	var cmr = plus.camera.getCamera();
	cmr.startVideoCapture(function(path) {
		callBack(path);
	}, function(e) {}, {
		filename: "_doc/camera/"
	});
}

function selectPhoto(callBack, extInfo, item) {
	extInfo += "";
	if(extInfo.indexOf("noselect") != -1) {
		var cmr = plus.camera.getCamera();
		cmr.captureImage(function(path) {
			if(extInfo.indexOf("cutheader") != -1) {
				compressHearderImage(path, callBack);
			} else {
				compressImage(path, callBack);
			}
		}, function(err) {}, getSupportPhoto(cmr));
	} else {
		var btnArray = [{
			title: "拍照"
		}, {
			title: "从相册选择"
		}, {
			title: "拍摄视频"
		}, {
			title: "从文件库选择"
		}];
		if(item == "onlyphoto") {
			btnArray = [{
				title: "拍照"
			}, {
				title: "从相册选择"
			}];
		} else if(item == "addlocation") {
			btnArray = [{
				title: "拍照"
			}, {
				title: "从相册选择"
			}, {
				title: "拍摄视频"
			}, {
				title: "从文件库选择"
			}, {
				title: "当前位置"
			}];
		}
		plus.nativeUI.actionSheet({
			title: "选择照片或文件",
			cancel: "取消",
			buttons: btnArray
		}, function(e) {
			var index = e.index;
			switch(index) {
				case 0:
					break;
				case 1:
					var cmr = plus.camera.getCamera();
					cmr.captureImage(function(path) {
							if(extInfo.indexOf("cutheader") != -1) {
								compressHearderImage(path, callBack);
							} else {
								compressImage(path, callBack);
							}
						},
						function(err) {}, getSupportPhoto(cmr));
					break;
				case 2:
					plus.gallery.pick(function(path) {
							if(extInfo.indexOf("cutheader") != -1) {
								compressHearderImage(path, callBack);
							} else {
								compressImage(path, callBack);
							}
						},
						function(err) {});
					break;
				case 3:
					recordvideo(callBack);
					break;
				case 4:
					popWindow("file.html?selfile=1");
					break;
				case 5:
					getGPSLocation(function(p) {
						var codns = p.coords;
						var location = codns.longitude + "|" + codns.latitude;
						callBack(location);
					}, "定位中，请稍后…");
					break;
			}
		});
	}
}

function getAddressByGPS(p, callBack) {
	if(p.addresses != null && p.addresses != "") {
		var address = p.address.province + p.address.city + p.address.district + p.address.street + p.address.poiName;
		address = address.replace(/undefined/img, "");
		callBack(address, p.address.province, p.address.city, p.address.district);
	} else {
		var regAddress = /<formatted_address>(.+?)<\/formatted_address>/img;
		var regPOI = /<sematic_description>(.+?)<\/sematic_description>/img;
		var regProvince = /<province>(.+?)<\/province>/img;
		var regCity = /<city>(.+?)<\/city>/img;
		var regDistrict = /<district>(.+?)<\/district>/img;
		var province = "",
			city = "",
			district = "";
		webBackground("http://api.map.baidu.com/geocoder/v2/?ak=qsqUs9ottVDjk79FfnIsGu41&callback=renderReverse&location=" + p.coords.latitude + "," + p.coords.longitude + "&output=xml&pois=1", "", function(content) {
			var address = "";
			var result = regAddress.exec(content);
			if(result != null) {
				address += RegExp.$1;
			}
			result = regPOI.exec(content);
			if(result != null) {
				address += RegExp.$1;
			}
			result = regProvince.exec(content);
			if(result != null) {
				province = RegExp.$1;
			}
			result = regCity.exec(content);
			if(result != null) {
				city = RegExp.$1;
			}
			result = regDistrict.exec(content);
			if(result != null) {
				district = RegExp.$1;
			}
			callBack(address, province, city, district);
		});
	}
}

function getSupportPhoto(cmr) {
	var photoPara = new Object();
	photoPara.filename = "_doc/camera/";
	photoPara.index = "1";
	var ress = cmr.supportedImageResolutions;
	for(var i = 0; i < ress.length; i++) {
		if(ress[i].Contains("1600")) {
			photoPara.resolution = ress[i];
			break;
		}
	}
	var fmts = cmr.supportedImageFormats;
	for(var i = 0; i < fmts.length; i++) {
		if(fmts[i].Contains("jpg") || fmts[i].Contains("jpeg")) {
			photoPara.format = fmts[i];
			break;
		}
	}
	return photoPara;
}
//缩放压缩图片

function compressImage(srcImg, callBack) {
	mui.toast("正在压缩，请稍后…");
	plus.zip.compressImage({
			src: srcImg,
			dst: srcImg.replace(/.jpg/img, "2.jpg"),
			format: "jpg",
			width: "400px",
			overwrite: true
		},
		function(e) {
			callBack(e.target);
		},
		function(ex) {
			MUIAlert("图像压缩失败：" + ex.message);
		});
}

function compressHearderImage(srcImg, callBack) {
	plus.zip.compressImage({
			src: srcImg,
			dst: srcImg.replace(/.jpg/img, "2.jpg"),
			format: "jpg",
			width: "1024px",
			overwrite: true
		},
		function(e) {
			callBack(e.target);
		},
		function(ex) {
			MUIAlert("图像载入失败：" + ex.message);
		});
}

function compressCardImage(srcImg, callBack, width) {
	mui.toast("正在压缩，请稍后…");
	plus.zip.compressImage({
			src: srcImg,
			dst: srcImg.replace(/.jpg/img, "2.jpg"),
			format: "jpg",
			width: width + "px",
			overwrite: true,
			rotate: 270
		},
		function(e) {
			if(e.size > 280 * 1024) {
				width -= 200;
				compressCardImage(srcImg, callBack, width);
			} else {
				callBack(e.target);
			}
		},
		function(ex) {
			MUIAlert("图像压缩失败：" + ex.message);
		});
}
var sessionObj = null;

function initSession() {
	if(sessionObj == null) {
		sessionObj = JSON.parse(getStorage("session"));
	}
}

function Session(key) {
	initSession();
	if(sessionObj != null) {
		return sessionObj[key];
	} else {
		return "";
	}
}

function setSession(key, value) {
	sessionObj[key] = value;
	setStorage("session", JSON.stringify(sessionObj));
}

function getStorage(key) {
	var value = plus.storage.getItem(key);
	if(value != null && value != undefined) {
		return decodeURI(value).replace(/‘/img, "'");
	} else {
		return "";
	}
}

function setStorage(key, value) {
	plus.storage.setItem(key, encodeURI(value.replace(/'/img, "‘")));
}

function webBackground(url, postdata, callback) {
	if(!url.StartsWith("http://")) {
		url = plus.storage.getItem("url") + url;
		initSession();
	}
	mui.ajax(url, {
		dataType: 'text', //服务器返回json格式数据
		type: 'post', //HTTP请求类型
		timeout: 30000, //超时时间设置为30秒；
		data: "sessioninfo=" + JSON.stringify(sessionObj) + postdata,
		success: function(result) {
			//服务器返回响应，根据响应结果，分析是否登录成功；			
			callback(result);
		},
		error: function(xhr, type, errorThrown) {}
	});
}

function webRequest(url, postdata, callback) {
	var wt = plus.nativeUI.showWaiting("请稍后…", {
		background: "rgba(0,0,0,0.3)",
		padlock: true
	});
	if(!url.StartsWith("http://")) {
		url = plus.storage.getItem("url") + url;
		initSession();
	}
	mui.ajax(url, {
		dataType: 'text', //服务器返回json格式数据
		type: 'post', //HTTP请求类型
		timeout: 30000, //超时时间设置为30秒；
		data: "sessioninfo=" + JSON.stringify(sessionObj) + postdata,
		success: function(result) {
			//服务器返回响应，根据响应结果，分析是否登录成功；	
			wt.close();
			callback(result);

		},
		error: function(xhr, type, errorThrown) {
			//异常处理；
			wt.close();
			MUIAlert("网络异常，请检查网络状态！");
		}
	});
}
var objs = new Object();

function E(id) {
	var con = objs[id];
	if(con == null) {
		var controlID = id;
		if(id == "txtCustomer") {
			if(document.getElementById(controlID) == null) {
				controlID = "ExtAddHeader1_txtCustomer";
			}
		} else if(id == "drpLinkMan") {
			controlID = "ExtAddHeader1_drpLinkMan";
		} else if(id == "drpProject") {
			controlID = "ExtAddHeader1_drpProject";
		}
		con = document.getElementById(controlID);
		if(con == null) {
			con = document.getElementById(controlID + "_drpInput");
		}
		if(con == null) {
			con = document.getElementById(controlID + "_chkInput");
		}
		if(con == null) {
			con = document.getElementById(controlID.replace(/init/igm, ""));
		}
		objs[id] = con;
	}
	return con;
}

function V(id) {
	var con = null;
	var con = objs[id];
	if(con == null) {
		var controlID = id;
		if(id == "txtCustomer") {
			if(document.getElementById(controlID) == null) {
				controlID = "ExtAddHeader1_txtCustomer";
			}
		} else if(id == "drpLinkMan") {
			controlID = "ExtAddHeader1_drpLinkMan";
		} else if(id == "drpProject") {
			controlID = "ExtAddHeader1_drpProject";
		}
		con = document.getElementById(controlID);
		if(con == null) {
			con = document.getElementById(controlID + "_drpInput");
		}
		if(con == null) {
			con = document.getElementById(controlID + "_chkInput");
		}
		if(con == null) {
			con = document.getElementById(controlID.replace(/init/igm, ""));
		}
		if(con == null) {
			con = 0;
		}
		objs[id] = con;
	}
	try {
		if(con != null && con != 0) {
			if(con.tagName == "SELECT") {
				if(con.options.length > 0) {
					return PARSENUM(con.options[con.selectedIndex].innerText.replace("—请选择—", ""));
				} else {
					return "";
				}
			} else if(con.tagName == "SPAN") {
				var childs = con.children;
				if(childs.length < 2) {
					return PARSENUM(con.innerText);
				} else {
					var tmp = "";
					for(var i = 0; i < childs.length; i++) {
						if(childs[i].checked) {
							if(childs[i].type == "checkbox") {
								if(tmp != "") {
									tmp += " " + childs[i].nextSibling.innerText;
								} else {
									tmp = childs[i].nextSibling.innerText;
								}
							} else {
								tmp += PARSENUM(childs[i].value);
							}
						}
					}
					return tmp;
				}
			} else if(id.indexOf("init") != -1) {
				return PARSENUM(con.getAttribute("initValue"));
			} else if(con.value != "") {
				return PARSENUM(con.value);
			} else {
				if(con.className.indexOf("Num") != -1) {
					return 0;
				} else {
					return "";
				}
			}
		} else {
			return 0;
		}
	} catch(ex) {
		return 0;
	}
}

function PARSENUM(numStr) {
	try {
		numStr = numStr + "";
		if(numStr.StartsWith("0") && !numStr.StartsWith("0.") && numStr.length > 1) {
			return numStr;
		}
		var num = numStr.replace(/,/igm, "");
		if(num.EndsWith("%")) {
			num = parseFloat(num.substr(0, num.length - 1)) / 100;
		}
		if(num != "" && !isNaN(num)) {
			return parseFloat(num);
		} else {
			return numStr;
		}
	} catch(ex) {
		return 0;
	}
}
String.prototype.Contains = function(s) {
	return(this.indexOf(s) > -1);
};
String.prototype.StartsWith = function(s) {
	return(this.substr(0, s.length) == s);
};
String.prototype.EndsWith = function(s, ignoreCase) {
	var L1 = this.length;
	var L2 = s.length;
	if(L2 > L1) {
		return false;
	}
	if(ignoreCase) {
		var oRegex = new RegExp(s + '$', 'i');
		return oRegex.test(this);
	} else {
		return(L2 == 0 || this.substr(L1 - L2, L2) == s);
	}
};
String.prototype.Trim = function() {
	return this.replace(/(^s*)|(s*$)/g, "");
}
String.prototype.LTrim = function() {
	return this.replace(/(^s*)/g, "");
}
String.prototype.Rtrim = function() {
	return this.replace(/(s*$)/g, "");
}

function request(name) {
	var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
	var r = window.location.search.substr(1).match(reg);
	if(r != null) return unescape(decodeURI(r[2]));
	return "";
}

function requestFromStr(name, urlStr) {
	var reg = new RegExp("(^|&|\\?)" + name + "=([^&]*)(&|$)");
	var r = urlStr.match(reg);
	if(r != null) return unescape(decodeURI(r[2]));
	return "";
}

function initAddPageInfo(callBack, userfields) {
	//	var sourceID = getPageSourceID();
	//	if (sourceID != "") {
	//		if (valid(sourceID, "viewsource")) {
	//			MUIAlert("对不起，暂无权限打开此页面！");
	//			mui.back();
	//		}
	//		if (!valid(sourceID, "btnDeletePage")) {
	//			var btnDeletePage = document.getElementById("btnDeletePage");
	//			if (btnDeletePage != null) {
	//				btnDeletePage.style.display = "none"
	//			}
	//		}
	//		if (!valid(sourceID, "editsource")) {
	//			var btnSavePage = document.getElementById("btnSavePage");
	//			if (btnSavePage != null) {
	//				btnSavePage.style.display = "none"
	//			}
	//		}
	//	}
	var id = request("id");
	if(id != "") {
		var info = "&optype=BindPageInfo&tblname=" + V("tblname") + "&id=" + id + "&userfields=" + userfields;
		pageRequest("/app/Handler.ashx", info, function(result) {
			if(result != null) {
				var fields = [].slice.call(document.querySelectorAll(".mui-input"));
				fields.forEach(function(f) {
					switch(f.tagName) {
						case "INPUT":
							f.value = result[f.id];
							break;
						case "TEXTAREA":
							if(f.className.Contains("mui-seloneuser") || f.className.Contains("mui-selmoreuser")) {
								f.innerHTML = result[f.id].text;
								f.value = result[f.id].text;
								f.nextElementSibling.value = result[f.id].value;
							} else if(f.className.Contains("mui-selshare")) {
								f.innerHTML = result[f.id].text;
								f.value = result[f.id].text;
								f.nextElementSibling.value = result[f.id].value;
								f.nextElementSibling.nextElementSibling.value = result[f.id].type;
							} else {
								f.innerHTML = result[f.id];
								f.value = result[f.id];
							}
							break;
						case "SELECT":
							f.options.forEach(function(o) {
								if(o.text == result[f.id]) {
									o.selected = true;
									return;
								}
							});
							break;
						case "UL":
							if(f.className.Contains("checkbox")) {
								var boxs = [].slice.call(f.querySelectorAll("input[type='checkbox']"));
								boxs.forEach(function(box) {
									if(result[f.id].Contains(box.parentElement.innerText)) {
										box.checked = true;
									}
								});
							} else if(f.className.Contains("radio")) {
								var boxs = [].slice.call(f.querySelectorAll("input[type='radio']"));
								boxs.forEach(function(box) {
									if(box.parentElement.innerText == result[f.id]) {
										box.checked = true;
										return;
									}
								});
							}
							break;
						case "IMG":
							if(result[f.id] != "") {
								var path = result[f.id];
								if(path.StartsWith("/")) {
									path = getStorage("url") + path;
								}
								f.src = path;
							}
							break;
						case "DIV":
						case "SPAN":
							if(f.className.Contains("mui-seloneuser") || f.className.Contains("mui-selmoreuser")) {
								f.innerHTML = result[f.id].text;
								if(f.nextElementSibling != null) {
									f.nextElementSibling.value = result[f.id].value;
								}
							} else {
								var reg = new RegExp("/uploadfiles", "img");
								f.innerHTML = result[f.id].replace(reg, getStorage("url") + "/uploadfiles").replace(/\n/img, "<br/>");
							}
							break;
					}
				});
				bindInputType(callBack);
			} else {
				bindInputType(callBack);
			}
		});
	} else {
		if(E("userid") != null) {
			E("userid").value = Session("userid");
		}
		bindInputType(callBack);
	}
}

function bindInputType(callBack) {
	mui(".mui-bar").on("tap", ".mui-action-close", function() {
		plus.webview.currentWebview().close();
	});
	if(document.querySelectorAll(".mui-input-area").length > 0) {
		var cityPicker3 = new mui.PopPicker({
			layer: 3
		});
		cityPicker3.setData(cityData3);
		mui("body").on("tap", ".mui-input-area", function(e) {
			var area = this;
			cityPicker3.show(function(items) {
				area.blur();
				area.value = (items[0] || {}).text + " " + (items[1] || {}).text + " " + (items[2] || {}).text;
			});
		});
	}
	if(mui.os.ios) {
		mui("body").on("input", ".mui-autocomplete", function() {
			var event = document.createEvent("KeyboardEvent");　　　　
			event.initKeyboardEvent("keydown", true, true, document.defaultView, "", 0, "", 0);
			this.dispatchEvent(event);
		}, false);
		var fullHeight = document.documentElement.clientHeight;
		window.addEventListener("resize", function() {
			if(document.documentElement.clientHeight < fullHeight) {
				document.body.style.paddingTop = "0px";
				var tblTitle = E("tblTitle");
				if(tblTitle != null) {
					tblTitle.style.display = "none";
				}
				var header = document.querySelector("header");
				if(header != null) {
					header.style.display = "none";
				}
			} else {
				document.body.style.paddingTop = "45px";

				var tblTitle = E("tblTitle");
				if(tblTitle != null) {
					tblTitle.style.display = "block";
				}
				var header = document.querySelector("header");
				if(header != null) {
					header.style.display = "block";
				}
			}
		});
	}
	mui.each(document.querySelectorAll('.mui-frmarea'), function(index, area) {
		area.value = E(area.getAttribute("unionid")).value;
		area.addEventListener("input", function() {
			E(area.getAttribute("unionid")).value = area.value;
		});
	});

	mui("body").on("tap", ".mui-input-date", function() {
		var dt = this;
		plus.nativeUI.pickDate(function(e) {
			var d = e.date;
			dt.value = d.getFullYear() + "-" + padLeft(d.getMonth() + 1, 2) + "-" + padLeft(d.getDate(), 2);
		}, function(e) {
			dt.value = "";
		}, {
			title: "请选择日期"
		});
	});
	mui("body").on("tap", ".mui-input-datetime", function() {
		var dt = this;
		plus.nativeUI.pickDate(function(e) {
			var d = e.date;
			dt.value = d.getFullYear() + "-" + padLeft(d.getMonth() + 1, 2) + "-" + padLeft(d.getDate(), 2);
			plus.nativeUI.pickTime(function(e2) {
				var t = e2.date;
				dt.value += " " + padLeft(t.getHours(), 2) + ":" + padLeft(t.getMinutes(), 2) + ":00";
			}, function(e) {}, {
				title: "请选择时间",
				is24Hour: true
			});
		}, function(e) {
			dt.value = "";
		}, {
			title: "请选择日期"
		});
	});
	getGPSLocation(function(p) {
		var codns = p.coords;
		gpsInfo = "y=" + codns.longitude + "&x=" + codns.latitude;
		var gpsCon = E("gpsinfo");
		if(gpsCon != null) {
			gpsCon.value = gpsInfo;
		}
		if(E("map") != null && !E("map").src.Contains("y=")) {
			var mapWin = document.getElementById("map").contentWindow;
			mapWin.setCenter(codns.longitude, codns.latitude);
		}
		getAddressByGPS(p, function(strAddr, province, city, district) {
			if(strAddr) {
				var addrs = mui(".mui-input-address");
				for(var i = 0; i < addrs.length; i++) {
					if(addrs[i].value == "") {
						addrs[i].value = strAddr;
					}
				}
				var areas = mui(".mui-input-area");
				var area = province + " " + city + " " + district;
				for(var i = 0; i < areas.length; i++) {
					if(areas[i].value.trim() == "") {
						areas[i].value = area;
					}
				}
			}
		});
	}, null, true);

	mui("body").on("tap", ".icon-tel", function() {
		var phone = this.parentElement.children[0];
		if(phone.tagName == "SPAN") {
			phone = phone.children[0];
		}
		if(phone.value != "") {
			plus.device.dial(phone.value, false);
		}
	});
	mui("body").on("tap", ".mui-icon-chatbubble", function() {
		var phone = this.parentElement.children[0];
		if(phone.tagName == "SPAN") {
			phone = phone.children[0];
		}
		if(phone.value != "") {
			window.open("sms:" + phone.value);
		}
	});
	mui("body").on("tap", ".mui-icon-email", function() {
		var phone = this.parentElement.children[0];
		if(phone.tagName == "SPAN") {
			phone = phone.children[0];
		}
		if(phone.value != "") {
			window.open("mailto:" + phone.value);
		}
	});

	mui("body").on("tap", ".mui-selmoreuser", function() {
		popWindow("selectuser.html?optype=&con=" + this.id + "&value=" + encodeURI(this.nextElementSibling.value));
	});
	mui("body").on("tap", ".mui-seloneuser", function() {
		popWindow("selectuser.html?optype=radio&con=" + this.id + "&value=" + encodeURI(this.nextElementSibling.value));
	});
	mui("body").on("tap", ".mui-selshare", function() {
		popWindow("selectshare.html?optype=checkbox&con=" + this.id + "&value=" + encodeURI(this.nextElementSibling.value) + "&sharetype=" + V("sharetype"));
	});
	mui("body").on("tap", ".mui-photo", function() {
		popWindow("cutheader.html?con=" + this.id);
	});
	mui("body").on("change", ".mui-input-hidden", function() {
		var conText = this.parentElement.children[0];
		conText.value += this.value;
		for(var i = 0; i < this.parentElement.children.length; i++) {
			if(this.parentElement.children[i].id.Contains("frm")) {
				this.parentElement.children[i].value += this.value;
				break;
			}
		}
	});
	mui("body").on("tap", ".uploadCamera", function() {
		setStorage("attfiles", this.parentElement.querySelector(".spanFiles").innerHTML);
		popWindow("multimedia.html?noselect=1&conid=" + this.id);
	});
	mui("body").on("tap", ".uploadFile", function() {
		setStorage("attfiles", this.parentElement.querySelector(".spanFiles").innerHTML);
		popWindow("multimedia.html?conid=" + this.id);
	});
	mui("body").on("tap", "#btnCamera", function() {
		modifyPhoto();
	});
	mui("body").on("tap", "#btnScanCard", function() {
		scanCard();
	});

	mui("body").on("tap", "#btnDeletePage", function() {
		mui.confirm("确定要删除该信息吗？", "系统提示", null, function(e) {
			if(e.index == 0) {
				if(request("id") == "") {
					mui.back();
				} else {
					var info = "&optype=deletepageinfo&tblname=" + V("tblname") + "&id=" + request("id");
					webRequest("/app/Handler.ashx", info, function(result) {
						MUIAlert(result);
						mui.back();
					});
				}
			}
		});
	});

	mui(".spanFiles").on("tap", "a", function() {
		setStorage("attfiles", this.parentElement.innerHTML);
		popWindow("multimedia.html?isview=1");
	});
	window.addEventListener("uploadpathchange", function(e) {
		if(e.detail.conid == "xiangguanfj") {
			E("uploadPath").value = e.detail.value;
		} else {
			E("uploadPath" + e.detail.conid).value = e.detail.value;
		}
	});

	mui("body").on("tap", "#btnSavePage", function() {
		var info = "&optype=savepageinfo&tblname=" + V("tblname") + "&id=" + request("id") + "&pageinfo=" + JSON.stringify(savePageInfo());
		webRequest("/app/Handler.ashx", info, function(result) {
			MUIAlert(result);
			mui.back();
		});

	});
	var btnMenuArray = [];
	var btns = ["btnInvalid", "btnTry", "btnCheck", "btnComplete", "btnUnComplete", "panelInsert", "panelZhiPai", "btnUndo", "linkForm", "linkReply", "showFlow"];
	btns.forEach(function(b) {
		var btn = E("ExtBtnTools1_" + b);
		if(btn != null) {
			btnMenuArray.push({
				title: btn.getAttribute("value"),
				id: btn.id
			});
		} else {
			var btn = E(b);
			if(btn != null) {
				btnMenuArray.push({
					title: btn.getAttribute("value"),
					id: btn.id
				});
			}
		}
	});
	if(btnMenuArray.length > 0) {
		mui("body").on("tap", "#btnMenu", function() {
			plus.nativeUI.actionSheet({
				title: "操作选项",
				cancel: "取消",
				buttons: btnMenuArray
			}, function(e) {
				if(e.index != 0) {
					var btn = E(btnMenuArray[e.index - 1].id);
					mui.trigger(btn, "click");
				}
			});
		});
	} else {
		if(E("btnMenu") != null) {
			E("btnMenu").style.display = "none";
		}
	}

	if(callBack != undefined) {
		callBack();
	}
}

function modifyPhoto() {
	selectPhoto(function(path) {
		appendFile(path);
		uploadFile(function(result) {
			var infos = result.split('$');
			if(infos[0].indexOf(":") != -1) {
				E("divPhoto").innerHTML = "<img id='photo' style='width:100%' src='" + plus.storage.getItem("url") + "/upLoadFiles/" + infos[0].substr(infos[0].indexOf(":") + 1) + "'/>";
				if(E("uploadPath") != null) {
					E("uploadPath").value = "P_" + infos[0];
				}
			}
		}, "", "传输中，请稍后…");
	}, "", "onlyphoto");
}

function savePageInfo() {
	var jsonObj = new Object();
	var fields = [].slice.call(document.querySelectorAll(".mui-input"));
	fields.forEach(function(f) {
		switch(f.tagName) {
			case "INPUT":
				jsonObj[f.id] = f.value;
				break;
			case "TEXTAREA":
				if(f.className.Contains("mui-seloneuser") || f.className.Contains("mui-selmoreuser")) {
					jsonObj[f.id] = f.nextElementSibling.value;
				} else if(f.className.Contains("mui-selshare")) {
					var obj = new Object();
					obj.value = f.nextElementSibling.value;
					obj.type = f.nextElementSibling.nextElementSibling.value;
					jsonObj[f.id] = obj;
				} else {
					jsonObj[f.id] = f.value;
				}
				break;
			case "SELECT":
				f.options.forEach(function(o) {
					if(o.selected) {
						jsonObj[f.id] = o.text;
						return;
					}
				});
				break;
			case "UL":
				if(f.className.Contains("checkbox")) {
					var boxs = [].slice.call(f.querySelectorAll("input[type='checkbox']"));
					boxs.forEach(function(box) {
						if(box.checked) {
							jsonObj[f.id] += box.parentElement.innerText + ',';
						}
					});
					if(jsonObj[f.id] != "") {
						jsonObj[f.id].substr(i, jsonObj[f.id].length - 1);
					}
				} else if(f.className.Contains("radio")) {
					var boxs = [].slice.call(f.querySelectorAll("input[type='radio']"));
					boxs.forEach(function(box) {
						if(box.checked) {
							jsonObj[f.id] = box.parentElement.innerText;
							return;
						}
					});
				}
				break;
			case "IMG":
				jsonObj[f.id] = f.src.replace(getStorage("url"), "");
				break;
			case "DIV":
				var reg = new RegExp(getStorage("url"), "img");
				jsonObj[f.id] = f.innerHTML.replace(reg, "");
				break;
		}
	});
	return jsonObj;
}

function pageRequest(url, postdata, callback) {
	var wt = plus.nativeUI.showWaiting("加载中…", {
		background: "rgba(0,0,0,0.3)",
		padlock: true
	});
	initSession();
	mui.ajax(plus.storage.getItem("url") + url, {
		dataType: 'json', //服务器返回json格式数据
		type: 'post', //HTTP请求类型
		timeout: 30000, //超时时间设置为30秒；
		data: "sessioninfo=" + JSON.stringify(sessionObj) + postdata,
		success: function(result) {
			//服务器返回响应，根据响应结果，分析是否登录成功；	
			callback(result);
			wt.close();
		},
		error: function(xhr, type, errorThrown) {
			//异常处理；
			wt.close();
			MUIAlert("网络异常，请检查网络状态！");
		}
	});
}

function downloadFile(url, callBack, extinfo) {
	var tmpFileName = requestFromStr("filename", url);
	var fileName = null;
	if(tmpFileName != "") {
		fileName = "_downloads/" + tmpFileName;
	} else {
		fileName = "_downloads/" + url.substr(url.lastIndexOf("/") + 1);
	}
	var localName;
	if(extinfo == undefined || extinfo == null || extinfo == "") {
		localName = fileName;
	} else {
		localName = "_downloads/" + extinfo;
	}
	plus.io.resolveLocalFileSystemURL(localName, function(f) {
		callBack(localName);
	}, function() {
		var dtask = plus.downloader.createDownload(url, {
			method: "GET",
			filename: localName
		}, function() {
			callBack(localName);
		});
		dtask.start();
	});
}

function copyToClip(txtContent) {
	if(plus.os.name == "Android") {
		var Context = plus.android.importClass("android.content.Context");
		var main = plus.android.runtimeMainActivity();
		var clip = main.getSystemService(Context.CLIPBOARD_SERVICE);
		plus.android.invoke(clip, "setText", txtContent);
	} else {
		var UIPasteboard = plus.ios.importClass("UIPasteboard");
		var generalPasteboard = UIPasteboard.generalPasteboard();
		generalPasteboard.setValueforPasteboardType(txtContent, "public.utf8-plain-text");
		var value = generalPasteboard.valueForPasteboardType("public.utf8-plain-text");
	}
}

function zan(tblName, id, callBack) {
	var info = "&optype=zan&tblname=" + tblName + "&id=" + id;
	webBackground("/app/Handler.ashx", info, function(result) {
		callBack(result);
	});
}

function reply(tblName, id, content, callBack) {
	var info = "&optype=sendreply&tblname=" + tblName + "&id=" + id + "&content=" + content;
	webBackground("/app/Handler.ashx", info, function(result) {
		callBack(result);
	});
}

function getReplys() {
	var info = "&optype=getreplys&tblname=" + V("tblname") + "&id=" + request("id");
	webBackground("/app/Handler.ashx", info, function(result) {
		var reg = new RegExp("/uploadfiles", "img");
		E("ulreplys").innerHTML = result.replace(reg, getStorage("url") + "/uploadfiles").replace(/\n/img, "<br/>");
	});
}

function postProxy(url) {
	var wt = plus.nativeUI.showWaiting("加载中…", {
		background: "rgba(0,0,0,0.3)",
		padlock: true
	});
	initSession();
	mui.ajax(plus.storage.getItem("url") + url, {
		dataType: 'text', //服务器返回json格式数据
		type: 'post', //HTTP请求类型
		timeout: 20000, //超时时间设置为10秒；
		data: "sessioninfo=" + JSON.stringify(sessionObj),
		success: function(result) {
			//服务器返回响应，根据响应结果，分析是否登录成功；			
			wt.close();
			document.write(result);

		},
		error: function(xhr, type, errorThrown) {
			//异常处理；
			wt.close();
			MUIAlert("网络异常，请检查网络状态！");
		}
	});
}

function popRemoteWindow(url) {
	if(url.indexOf("/") == -1) {
		url = "/" + url;
	}
	var aniShow = "fade-in";
	var webview_style = {
		popGesture: "close",
		softinputMode: "adjustResize"
	};
	if(url.indexOf("?") != -1) {
		url += "&sessionid=" + Session("sessionid")
	} else {
		url += "?sessionid=" + Session("sessionid")
	}
	openRemoteWindow({
		id: url,
		url: Session("url") + url.substr(url.lastIndexOf("/")),
		styles: webview_style,
		show: {
			aniShow: aniShow
		},
		waiting: {
			autoShow: true
		}
	});
}

function openRemoteWindow(url, id, options) {
	if(!window.plus) {
		return;
	}
	if(typeof url === 'object') {
		options = url;
		url = options.url;
		id = options.id || url;
	} else {
		if(typeof id === 'object') {
			options = id;
			id = url;
		} else {
			id = id || url;
		}
	}
	options = options || {};
	var params = options.params || {};
	var webview, nShow, nWaiting;
	if(mui.webviews[id]) { //已缓存
		var webviewCache = mui.webviews[id];
		webview = webviewCache.webview;
		//需要处理用户手动关闭窗口的情况，此时webview应该是空的；
		if(!webview || !webview.getURL()) {
			//再次新建一个webview；
			options = mui.extend(options, {
				id: id,
				url: url,
				preload: true
			}, true);
			webview = mui.createWindow(options);
		}
		//每次show都需要传递动画参数；
		//预加载的动画参数优先级：openWindow配置>preloadPages配置>mui默认配置；
		nShow = webviewCache.show;
		nShow = options.show ? mui.extend(nShow, options.show) : nShow;
		webview.show(nShow.aniShow, nShow.duration, function() {
			triggerPreload(webview);
			trigger(webview, 'pagebeforeshow', false);
		});

		webviewCache.afterShowMethodName && webview.evalJS(webviewCache.afterShowMethodName + '(\'' + JSON.stringify(params) + '\')');
		return webview;
	} else { //新窗口
		if(options.createNew !== true) {
			webview = plus.webview.getWebviewById(id);
			if(webview) { //如果已存在
				nShow = mui.showOptions(options.show);
				webview.show(nShow.aniShow, nShow.duration, function() {
					triggerPreload(webview);
					trigger(webview, 'pagebeforeshow', false);
				});
				return webview;
			}
		}
		//显示waiting
		var waitingConfig = mui.waitingOptions(options.waiting);
		if(waitingConfig.autoShow) {
			nWaiting = plus.nativeUI.showWaiting("加载中，请稍后…", {
				background: "rgba(0,0,0,0.3)",
				padlock: true
			});
		}
		//创建页面
		options = mui.extend(options, {
			id: id,
			url: url,
			preload: false
		});

		webview = mui.createWindow(options);
		//显示

		nShow = mui.showOptions(options.show);
		if(nShow.autoShow) {
			webview.addEventListener("loading", function() {
				nShow.duration = 500;
				//显示页面
				webview.show(nShow.aniShow, nShow.duration, function() {
					//					triggerPreload(webview);
					//					trigger(webview, 'pagebeforeshow', false);
				});
			}, false);
			window.addEventListener("windowloaded", function() {
				if(nWaiting) {
					nWaiting.close();
				}
			}, false);
			webview.addEventListener("loaded", function() {
				//关闭等待框
				if(nWaiting) {
					nWaiting.close();
				}
				webview.appendJsFile("_www/js/mui.min.js");
				webview.appendJsFile("_www/js/city.data-3.js");
				webview.appendJsFile("_www/js/mui.listpicker.js");
				webview.appendJsFile("_www/js/mui.poppicker.js");
				webview.appendJsFile("_www/js/common.js");
				webview.appendJsFile("_www/js/html2canvas.js");
				webview.appendJsFile("_www/js/raphael-min.js");
				webview.show();
				webview.showed = true;
				options.afterShowMethodName && webview.evalJS(options.afterShowMethodName + '(\'' + JSON.stringify(params) + '\')');

			}, false);
		}
	}
	return webview;
}

function printContent(container, printType) {
	try {
		if(printType == "image") {
			html2canvas(container, {
				allowTaint: true,
				taintTest: false,
				onrendered: function(canvas) {
					//生成base64图片数据
					var imgData = canvas.toDataURL();
					webRequest("/app/Handler.ashx", "&optype=printimage&imgdata=" + imgData + "&os=" + plus.os.name, function(result) {
						if(result != "") {
							result = "GzMA|HUwAAA==|" + result;
							if(plus.os.name == "Android") {
								sendDataToDeviceAndroid(result);
							} else {
								sendDataToDeviceiOS(result);
							}
						}

					});
				}
			});
		} else {
			var data = container.innerText;
			console.log(data);
			if(data.indexOf("body{color:#000;}") != -1) {
				data = data.substring(0, data.indexOf("body{color:#000;}"));
			}

			var data = "GzNN|HUwg|AA==|" + data; //左边距初始化  1d4c2000
			data = data.replace(/\n/img, "\n|");
			data = data.replace(/\[居中开始\]/img, "|G2EB|");
			data = data.replace(/\[居中结束\]/img, "|G2EA|");
			data = data.replace(/\[放大开始\]/img, "|HSER|");
			data = data.replace(/\[放大结束\]/img, "|HSEA|");
			//console.log(data);
			if(plus.os.name == "Android") {
				sendDataToDeviceAndroid(data);
			} else {
				sendDataToDeviceiOS(data);
			}
		}
	} catch(ex) {
		MUIAlert("打印失败,请检查蓝牙设备!");
	}
}

function sendDataToDeviceiOS(data) {

	// 声明的JS“扩展插件别名”
	var _BARCODE = 'BlueTooth',
		B = window.plus.bridge;
	var BlueTooth = {
		// 声明异步返回方法
		callNative: function(funcName, Args1, Args2, Args3, Args4, successCallback, errorCallback) {
			var success = typeof successCallback !== 'function' ? null : function(args) {
					successCallback(args);
				},
				fail = typeof errorCallback !== 'function' ? null : function(code) {
					errorCallback(code);
				};
			callbackID = B.callbackId(success, fail);
			// 通知Native层plugintest扩展插件运行funcName方法
			return B.exec(_BARCODE, funcName, [callbackID, Args1, Args2, Args3, Args4]);
		}
	};
	window.plus.BlueTooth = BlueTooth;

	document.addEventListener("bluetoothStateChanged", function(e) {
		if(e.arguments.indexOf("MAC=") != -1) {
			var mac = e.arguments.substring(4);
			setStorage("bluetoothmac", mac)
			verifyDevice(mac);
		}
		writeToLog(e.arguments);
	}, false);
	document.addEventListener("bluetoothAlert", function(e) {
		MUIAlert(e.arguments);
	}, false);
	var tmpMac = getStorage("bluetoothmac");
	if(tmpMac == "") {
		window.plus.BlueTooth.callNative("printData", "Gprint", "E7810A71-73AE-499D-8C15-FAA9AEF0C3F2", "BEF8D6C9-9C21-4C9E-B632-BD58C1009F9F", data + "|G0r/", writeToLog, writeToLog);
	} else if(verifyDevice(tmpMac)) {
		window.plus.BlueTooth.callNative("printData", "Gprinter", "E7810A71-73AE-499D-8C15-FAA9AEF0C3F2", "BEF8D6C9-9C21-4C9E-B632-BD58C1009F9F", data + "|G0r/", writeToLog, writeToLog);
	}
}

function sendDataToDeviceAndroid(data) {
	//注册类
	var main = plus.android.runtimeMainActivity();
	var IntentFilter = plus.android.importClass('android.content.IntentFilter');
	var BluetoothAdapter = plus.android.importClass("android.bluetooth.BluetoothAdapter");
	var BluetoothDevice = plus.android.importClass("android.bluetooth.BluetoothDevice");
	var bdevice = new BluetoothDevice();
	var BAdapter = BluetoothAdapter.getDefaultAdapter();
	//setStorage("bluetoothmac","");
	var mac = getStorage("bluetoothmac");
	var BleDevice = null;
	if(mac != "") {
		BleDevice = BAdapter.getRemoteDevice(mac);
	}
	var printData = function() {
		var UUID = plus.android.importClass("java.util.UUID");
		var uuid = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");
		var bluetoothSocket = BleDevice.createInsecureRfcommSocketToServiceRecord(uuid);
		plus.android.importClass(bluetoothSocket);
		bluetoothSocket.connect();
		writeToLog('设备已连接');
		if(bluetoothSocket.isConnected() && verifyDevice(BleDevice.getAddress())) {
			setStorage("bluetoothmac", BleDevice.getAddress());
			writeToLog('开始打印');
			var Base64 = plus.android.importClass("android.util.Base64");
			var outputStream = bluetoothSocket.getOutputStream();
			plus.android.importClass(outputStream);
			var lines = data.split('|');
			for(var i = 0; i < lines.length; i++) {
				if(lines[i] != "") {
					var bytes = null;
					if(lines[0] == "GzMA") {
						bytes = Base64.decode(lines[i], Base64.DEFAULT);
					} else {
						if(lines[i].length == 4) {
							bytes = Base64.decode(lines[i], Base64.DEFAULT);
						}
						if(bytes == null || bytes.length == 0) {
							bytes = plus.android.invoke(lines[i], "getBytes", "gbk");
						}
					}
					//console.log(lines[i] + ":" + bytes);
					outputStream.write(bytes);
					outputStream.flush();
				}
			}
			setTimeout(function() {
				var movePaper = Base64.decode("G0r/", Base64.DEFAULT);
				outputStream.write(movePaper);
				outputStream.flush();
				device = null //这里关键
				bluetoothSocket.close(); //必须关闭蓝牙连接否则意外断开的话打印错误	
				writeToLog('打印完毕，设备断开');
			}, 1000);
		} else {
			MUIAlert("设备连接失败,请检查蓝牙设备!");
		}
	};
	if(BleDevice == null) {
		var filter = new IntentFilter();
		writeToLog("开始搜索设备");
		BAdapter.startDiscovery(); //开启搜索
		var receiver = plus.android.implements('io.dcloud.android.content.BroadcastReceiver', {
			onReceive: function(context, intent) { //实现onReceiver回调函数
				plus.android.importClass(intent); //通过intent实例引入intent类，方便以后的‘.’操作
				if(intent.getAction() == "android.bluetooth.adapter.action.DISCOVERY_FINISHED") {
					main.unregisterReceiver(receiver); //取消监听
				} else if(intent.getAction() == "android.bluetooth.device.action.FOUND") {
					writeToLog("发现设备");
					BleDevice = intent.getParcelableExtra(BluetoothDevice.EXTRA_DEVICE);
					writeToLog("连接设备：" + BleDevice.getName());
					if(BleDevice.getName().indexOf("Gprinter") != -1) {
						main.unregisterReceiver(receiver); //取消监听
						if(BleDevice.getBondState() != bdevice.BOND_NONE) {
							if(BleDevice.createBond()) {
								writeToLog("配对成功");
							}
						}
						printData();
					}
				}
			}

		});
		filter.addAction(bdevice.ACTION_FOUND);
		filter.addAction(BAdapter.ACTION_DISCOVERY_STARTED);
		filter.addAction(BAdapter.ACTION_DISCOVERY_FINISHED);
		filter.addAction(BAdapter.ACTION_STATE_CHANGED);
		main.registerReceiver(receiver, filter); //注册监听

	} else {
		printData();
	}
}

function verifyDevice(mac) {
	if(mac == null || mac == undefined || mac == "") {
		return true;
	} else if(getStorage(mac) == "verifyed") {
		return true;
	} else {
		webBackground("http://www.orsoft.org/verifyuser.aspx", "&userid=" + mac + "&smsopr=count", function(result) {
			if(result == "1") {
				setStorage(mac, "verifyed");
			}
		});
		return false;
	}
}

function writeToLog(message) {
	var divResult = E("divResult");
	if(divResult != null) {
		if(message == "") {
			divResult.innerHTML = "";
		} else {
			divResult.innerHTML += message + "<br>";
		}
	}
}

function relogin() {
	var wins = plus.webview.all();
	var main = plus.webview.getLaunchWebview();
	var curWin = plus.webview.currentWebview();
	for(var i = 0; i < wins.length; i++) {
		if(wins[i].id == main.id) {
			wins[i].loadURL("file://" + plus.io.convertLocalFileSystemURL("_www/login.html?relogin=1"));
		} else if(wins[i].id != curWin.id) {
			wins[i].close();
		}
	}
	curWin.close();
}

function onMUIReady() {
	if(webViewClose) {
		plus.webview.currentWebview().close();
	} else {
		mui.back = function() {
			plus.webview.currentWebview().close();
		}
		var opener = plus.webview.currentWebview().opener();
		mui.fire(opener, "windowloaded");
		bindInputType();
	}
}

function MUIAlert(content) {
	mui.alert(content, getAppName());
}

function scanCard() {
	var cmr = plus.camera.getCamera();
	cmr.captureImage(function(path) {
		compressCardImage(path, function(path2) {
			//			document.getElementById("photo").src = path2 + "?rnd=" + Math.random();
			appendFile(path2);
			uploadFile(function(result) {
				var infos = result.split('$');
				if(infos[0].indexOf(":") != -1) {
					//					document.getElementById("photo").src = plus.storage.getItem("url") + "/upLoadFiles/" + infos[0].substr(infos[0].indexOf(":") + 1);
				}
				if(document.URL.toLowerCase().Contains("linkwayadd")) {
					var fields = infos[1].replace(/\r\n/img, "|").split('|');
					for(var i = 0; i < fields.length; i++) {
						var keyValue = fields[i].split(':');
						if(keyValue[0] == "xingming") {
							keyValue[0] = "txtName";
						} else if(keyValue[0] == "kehumc") {
							keyValue[0] = "txtCustomer";
						}
						SetCardInfo(E(keyValue[0]), keyValue[1]);
					}
				} else if(document.URL.toLowerCase().Contains("customeradd")) {
					var fields = infos[1].replace(/\r\n/img, "|").split('|');
					setStorage("lastcard", infos[1]);
					for(var i = 0; i < fields.length; i++) {
						var keyValue = fields[i].split(':');
						if(keyValue[0] == "xingming") {
							keyValue[0] = "zhuyaolxr";
						} else if(keyValue[0] == "kehumc") {
							keyValue[0] = "txtName";
						}
						SetCardInfo(E(keyValue[0]), keyValue[1]);
					}
				}
			}, "scancard", "识别中，请稍后…");
		}, 1200);
	}, function(ex) {}, getSupportPhoto(cmr));
}

function SetCardInfo(con, value) {
	try {
		if(con != null && con.getAttribute("readonly") != "readonly") {
			if(con.tagName == "SPAN") {
				var childs = con.getElementsByTagName("INPUT");
				if(childs.length > 1) {
					for(var i = 0; i < childs.length; i++) {
						if(childs[i].value == value || childs[i].nextSibling.innerText == value) {
							if(childs[i].checked != true) {
								childs[i].checked = true;
							}
						} else {
							if(childs[i].checked != false) {
								childs[i].checked = false;
							}
						}
					}
				} else {
					con.innerHTML = value;
				}
			} else if(con.tagName == "SELECT") {
				var selected = false;
				for(var i = 0; i < con.options.length; i++) {
					if(con.options[i].text == value) {
						con.options[i].selected = true;
						selected = true;
						break;
					}
				}
				if(!selected) {
					var opt = new Option(value, value);
					opt.selected = true;
					con.options.add(new Option(value, value));
				}
			} else {
				con.value = value
			}
		}
	} catch(ex) {}
}

function loadLastCard() {
	var lastCard = getStorage("lastcard");
	if(lastCard != "") {
		var btnArray = ['是', '否'];
		mui.confirm('是否载入上次名片扫描结果？', getAppName(), btnArray, function(e) {
			if(e.index == 0) {
				var fields = lastCard.replace(/\r\n/img, "|").split('|')
				for(var i = 0; i < fields.length; i++) {
					var keyValue = fields[i].split(':');
					if(keyValue[0] == "xingming") {
						keyValue[0] = "txtName";
					} else if(keyValue[0] == "kehumc") {
						keyValue[0] = "txtCustomer";
					}
					SetCardInfo(E(keyValue[0]), keyValue[1]);
				}
			}
		});
		setStorage("lastcard", "");
	}
}
var gpsRequest = false;

function getGPSLocation(callBack, waittingMsg, getAddress) {
	if(getAddress == undefined) {
		getAddress = false;
	}
	if(waittingMsg != undefined && waittingMsg != null) {
		mui.toast(waittingMsg);
	}
	gpsRequest = true;
	plus.geolocation.getCurrentPosition(function(p) {
		gpsRequest = false;
		gpsLocation = p;
		callBack(p);
	}, function(e) {
		gpsRequest = false;
		if(waittingMsg != undefined && waittingMsg != null) {
			mui.toast("获取位置失败，请打开系统定位功能！");
		}
	}, {
		provider: 'baidu',
		geocode: getAddress
	});
	setTimeout(function() {
		if(gpsRequest && gpsLocation != null) {
			callBack(gpsLocation);
		}
	}, 3000);
}

function clearAddressbook(callBack) {
	plus.contacts.getAddressBook(plus.contacts.ADDRESSBOOK_PHONE, function(addressbook) {
		addressbook.find(null, function(contacts) {
				var i = 0;
				var removeNext = function() {
					if(i < contacts.length) {
						var contact = contacts[i];
						i++;
						contact.remove(removeNext, removeNext);
					} else {
						callBack();
					}
				};
				removeNext();
			},
			function(e) {}, {
				multiple: true,
				filter: [{
					logic: "and",
					field: "displayName",
					value: "☆*"
				}]
			});
	});
}

function addToAddressbook() {
	var storageNums = getStorage("storageNums");
	webBackground("/app/Handler.ashx", "&optype=gethotcustomers&storagenums=" + storageNums, function(result) {
		if(result != "") {
			plus.contacts.getAddressBook(plus.contacts.ADDRESSBOOK_PHONE, function(addressbook) {
				plus.nativeUI.showWaiting("同步缓存数据中，请稍后…", {
					background: "rgba(0,0,0,0.3)",
					padlock: true
				});
				var nums = result.split('|');
				var i = 0;
				var addToContacts = function() {
					if(i < nums.length) {
						var numInfo = nums[i].split(',');
						var phoneNum = numInfo[0];
						var companyName = numInfo[1];
						var phoneName = numInfo[2];
						storageNums += "," + phoneNum;
						i++;
						addressbook.find(null, function(contacts) {
								if(contacts.length == 0) {
									var contact = addressbook.create();
									contact.name = {
										givenName: '☆' + phoneName + '-' + companyName
									};
									contact.phoneNumbers = [{
										type: "mobile",
										value: phoneNum,
										preferred: false
									}];
									contact.save(addToContacts, addToContacts);
								} else {
									var contact = contacts[0];
									if(contact.phoneNumbers == null) {
										contact.phoneNumbers = [];
									}
									contact.phoneNumbers.push({
										type: "mobile",
										value: phoneNum,
										preferred: false
									});
									contact.save(addToContacts, addToContacts);
								}
							},
							addToContacts, {
								multiple: true,
								filter: [{
									logic: "and",
									field: "displayName",
									value: '☆' + phoneName + '-' + companyName
								}]
							});
					} else {
						setStorage("storageNums", storageNums);
						plus.nativeUI.closeWaiting();
					}
				};
				addToContacts();
			});
		}
	});
}

function shareMessage(url, title, content) {
	if(getAppName() != appDefName) {
		return;
	}
	var pars = [url, title, content];
	var shares = {};
	plus.share.getServices(function(s) {
		if(s && s.length > 0) {
			for(var i = 0; i < s.length; i++) {
				var t = s[i];
				shares[t.id] = t;
			}
		}
	}, function() {
		alert("获取分享服务列表失败");
	});
	var ids = [{
			id: "weixin",
			ex: "WXSceneSession"
		}, {
			id: "weixin",
			ex: "WXSceneTimeline"
		}, {
			id: "qq"
		}],
		bts = [{
			title: "发送给微信好友"
		}, {
			title: "分享到微信朋友圈"
		}, {
			title: "分享到QQ"
		}];
	plus.nativeUI.actionSheet({
		cancel: "取消",
		buttons: bts
	}, function(e) {
		var i = e.index;
		if(i > 0) {
			var s_id = ids[i - 1].id;
			var share = shares[s_id];
			var msg = {
				extra: {
					scene: ids[i - 1].ex
				}
			};
			msg.href = pars[0];
			msg.title = pars[1];
			if(msg.title == "") {
				msg.title = "掌乾坤内容分享";
			}
			msg.content = pars[2];
			msg.thumbs = ["_www/images/logo.png"];
			if(share.authenticated) {
				share.send(msg, function() {}, function(e) {});
			} else {
				share.authorize(function() {
					share.send(msg, function() {}, function(e) {});
				}, function(e) {
					MUIAlert("认证授权失败：" + e.code + " - " + e.message);
				});
			}
		}
	});
}